<template>
	<view class="container">
		<uni-section title="基础信息" type="line">
			<uni-forms ref="infoForm" :rules="rules" :modelValue="formData" :label-width="90">
				<uni-forms-item required label="姓名" name="name">
					<uni-easyinput type="text" v-model="formData.name" placeholder="请输入姓名" />
				</uni-forms-item>
				<uni-forms-item required label="性别" name="sex">
					<uni-data-checkbox v-model="formData.sex" :localdata="sexs" />
				</uni-forms-item>
				<uni-forms-item required label="手机号" name="phone">
					<view class="phoneBox">
						<uni-easyinput disabled type="text" v-model="formData.phone" placeholder="手机号" />
						<button type="primary" :plain="true" style="border: none;"  size="mini" open-type="getPhoneNumber" @getphonenumber="decryptPhoneNumber">获取手机号</button>
					</view>
				</uni-forms-item>
				<uni-forms-item name="birthday" label="出生日期">
					<uni-datetime-picker type="date" v-model="formData.birthday" />
				</uni-forms-item>
			</uni-forms>
		</uni-section>
		<uni-data-checkbox class="isShowAddr" v-model="isShowAddr" multiple :localdata="isShowArr" />
		<uni-section title="地址信息" sub-title="（富裕街道居民请填写地址信息）" type="line"  v-if="isShowAddr.length > 0">
			<uni-forms ref="addrForm" :modelValue="formData" :label-width="90">
				<uni-forms-item label="小区选择">
					<uni-data-picker v-model="formData.estateId" :map="pickerMap" :localdata="items" placeholder="请选择地址" popup-title="请选择地址" @change="onchange"></uni-data-picker>
				</uni-forms-item>
				<uni-forms-item label="楼栋选择">
					<uni-data-picker v-model="formData.buildingId" :localdata="range" placeholder="请选择小区" popup-title="请选择小区" @change="selectChange"></uni-data-picker>
				</uni-forms-item>
				<uni-forms-item label="单元选择" v-if="house.unit && house.unit.length > 0">
					<uni-data-picker v-model="formData.unit" :localdata="house.unit" placeholder="请选择单元" popup-title="请选择单元" @change="unitChange"></uni-data-picker>
				</uni-forms-item>
				<uni-forms-item label="楼层选择" v-if="house.floor && house.unit.length > 0">
					<uni-data-picker v-model="formData.floor" :localdata="house.floor" placeholder="请选择楼层" popup-title="请选择楼层" @change="floorChange"></uni-data-picker>
				</uni-forms-item>
				<uni-forms-item label="门牌选择" v-if="house.number && house.number !== ''">
					<uni-data-picker v-model="formData.houseId" :localdata="house.number" placeholder="请选择门牌" popup-title="请选择门牌" @change="houseChange"></uni-data-picker>
				</uni-forms-item>
			</uni-forms>
		</uni-section>
		<button class="btn" type="primary" @click="submit('infoForm')">提交</button>
	</view>
</template>

<script>
	import request from '../../api/user.js';
	import requestLogin from '../../api/login.js';
	const appid = uni.getAccountInfoSync().miniProgram.appId;
	export default {
		data() {
			return {
				// 勾选成为居民
				isShowAddr: 0,
				isShowArr: [{ text: '我是富裕街道居民', value: 1 }],
				role: '',
				path: null,
				formData: {},
				sexs: [
					{ text: '男', value: 1 },
					{ text: '女', value: 0 },
				],
				items: [],
				pickerMap: {
					text: 'label',
					value: 'interId'
				},
				range: [],
				house: {},
				building: [],
				unit: '',
				// 校验规则
				rules: {
					name: {
						rules: [{
							required: true,
							errorMessage: '姓名不能为空'
						}]
					},
					sex: {
						rules: [{
							required: true,
							errorMessage: '性别不能为空'
						}]
					},
					phone: {
						rules: [{
							required: true,
							errorMessage: '电话不能为空'
						}]
					},
				},
			}
		},
		async mounted() {
			const res = await request.addrTreeSelect();
			this.items = res.data;
		},
		methods: {
			// 获取手机号
			async decryptPhoneNumber(e) {
				const res = await requestLogin.getPhone({ code: e.detail.code, appid: appid });
				this.$set(this.formData, 'phone', res.phone_info.phoneNumber);
			},
			// 小区选择
			async onchange(e) {
				const val = e.detail.value[e.detail.value.length - 1].value;
				const res = await request.buildingList({ estateId: val });
				this.range = res.rows.map(e => ({ ...e, text: `${e.number}栋`, value: e.buildingId }));
				// 删除选项
				// if (e.isUpdate) return;
				delete this.formData.buildingId
				delete this.formData.unit
				delete this.formData.floor
				delete this.formData.houseId
			},
			// 楼栋选择
			async selectChange(e) {
				if (!e || e == '' || e.detail.value.length <= 0) return;
				const res = await request.houseList({ buildingId: e.detail.value[0].value });
				this.building = res.rows;
				const list = [];
				const numList = [];
				const unit = res.rows.filter(j => j.unit !== null).map(j => ({ ...j, text: `${j.unit}单元`, value: j.unit }));
				const number = res.rows.filter(j => j.number !== null).map(j => ({ ...j, text: `${j.number}号`, value: j.houseId }));
				unit.forEach(k => {
					const isunit = list.find(j => j.unit == k.unit);
					if (!isunit) list.push(k);
				});
				this.$set(this.house, 'unit', list);
				number.forEach(k => {
					const isunit = numList.find(j => j.number == k.number);
					if (!isunit) numList.push(k);
				});
				this.$set(this.house, 'number', numList);
				// delete this.formData.buildingId
				delete this.formData.unit
				delete this.formData.floor
				delete this.formData.houseId
			},
			// 单元选择
			unitChange(e) {
				if (!e || e == '' || e.detail.value.length <= 0) return;
				this.unit = e.detail.value[0].value;
				const list = [];
				const floor = this.building.filter(j => j.unit == e.detail.value[0].value).map(j => ({ ...j, text: `${j.floor}层`, value: j.floor }));
				floor.forEach(k => {
					const isunit = list.find(j => j.floor == k.floor);
					if (!isunit) list.push(k);
				});
				this.$set(this.house, 'floor', list);
				// delete this.formData.buildingId
				// delete this.formData.unit
				delete this.formData.floor
				delete this.formData.houseId
			},
			// 楼层选择
			floorChange(e) {
				if (!e || e == '' || e.detail.value.length <= 0) return;
				const list = [];
				const number = this.building.filter(j => j.floor == e.detail.value[0].value && j.unit == this.unit).map(j => ({ ...j, text: `${j.number}号`, value: j.houseId }));
				number.forEach(k => {
					const isunit = list.find(j => j.number == k.number);
					if (!isunit) list.push(k);
				});
				this.$set(this.house, 'number', list);
				// delete this.formData.buildingId
				// delete this.formData.unit
				// delete this.formData.floor
				delete this.formData.houseId
			},
			// 门牌选择
			houseChange(e) {
				if (!e || e == '' || e.detail.value.length <= 0) return;
				const dept = this.house.number.find(j => j.houseId == e.detail.value[0].value);
				this.formData.deptId = dept.deptId;
			},
			// 提交
			async submit(ref) {
				this.$refs[ref].validate(async (err, formdata) => {
					if (!err) {
						// 判断勾选后是否添加地址
						if (this.isShowAddr.length > 0) {
							if (!this.formData.estateId || !this.formData.buildingId || !this.formData.houseId == null) {
								uni.showToast({
									title: '请填写完整地址信息',
									icon: 'error',
									duration: 2000,
								});
								return;
							}
						}
						// 添加用户
						const res = await request.addUser(this.formData);
						uni.setStorageSync('token', res.data.token);
						uni.setStorageSync('userinfo', res.data.user);
						uni.setStorageSync('role', res.data.role);
						uni.showToast({
							title: '添加成功',
							duration: 2000,
						});
						if (this.path && this.path !== null) {
							uni.redirectTo({
								url: this.path
							})
						}
						uni.navigateBack()
					}
				})
			},
		},
		onLoad(option) {
			this.path == option.path;
		}
	}
</script>

<style>
	.uni-section {
		padding-bottom: 10px;
		margin-bottom: 10px;
	}
	.uni-select__selector {
		z-index: 999 !important;
	}
	.uni-forms, .btn {
		width: 90%;
		margin: 10px auto;
	}
	.phoneBox {
		display: flex;
	}
	.isShowAddr {
		width: 90%;
		margin: 0 auto;
		display: block;
	}
</style>
